#!/usr/bin/env bash
# Copyright 2014 GSI, Inc. All rights reserved.
#
#
#=============================================================================
# ***** create_dir  *****
#=============================================================================
create_dir()
{
   if [ ! -d "$1" ]; then
      mkdir -p "$1"
   fi
}
#=============================================================================
# ***** MAIN  *****
#=============================================================================
export DDS_LOCATION=/usr

# local folder
eval LOCAL_DDS="$HOME/.DDS"

# create local DDS directories
create_dir "$LOCAL_DDS"

## create a default configuration file if needed
DDS_CFG=$(dds-user-defaults --ignore-default-sid -p)
if [ -z "$DDS_CFG" ]; then
   dds-user-defaults --ignore-default-sid -d -c "$LOCAL_DDS/DDS.cfg"
fi
